# Forked by George Watson (https://github.com/takeiteasy)
# Copyright (c) 2025.
# All rights reserved.
#
# trivial-graphics
#
# Copyright (C) 2025  George Watson
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.
#
# Original license:
#
# Created by Adam Griffiths (https://github.com/adamlwgriffiths)
#
# Copyright (c) 2015.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met: 
#
# 1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer. 
# 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution. 
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# The views and conclusions contained in the software and documentation are those
# of the authors and should not be interpreted as representing official policies, 
# either expressed or implied, of the FreeBSD Project.

from OpenGL import GL

_variable_enums = dict((int(enum), enum) for enum in [
GL.GL_FLOAT,
GL.GL_FLOAT_VEC2,
GL.GL_FLOAT_VEC3,
GL.GL_FLOAT_VEC4,
GL.GL_DOUBLE,
GL.GL_DOUBLE_VEC2,
GL.GL_DOUBLE_VEC3,
GL.GL_DOUBLE_VEC4,
GL.GL_INT,
GL.GL_INT_VEC2,
GL.GL_INT_VEC3,
GL.GL_INT_VEC4,
GL.GL_UNSIGNED_INT,
GL.GL_UNSIGNED_INT_VEC2,
GL.GL_UNSIGNED_INT_VEC3,
GL.GL_UNSIGNED_INT_VEC4,
GL.GL_BOOL,
GL.GL_BOOL_VEC2,
GL.GL_BOOL_VEC3,
GL.GL_BOOL_VEC4,
GL.GL_FLOAT_MAT2,
GL.GL_FLOAT_MAT3,
GL.GL_FLOAT_MAT4,
GL.GL_FLOAT_MAT2x3,
GL.GL_FLOAT_MAT2x4,
GL.GL_FLOAT_MAT3x2,
GL.GL_FLOAT_MAT3x4,
GL.GL_FLOAT_MAT4x2,
GL.GL_FLOAT_MAT4x3,
GL.GL_DOUBLE_MAT2,
GL.GL_DOUBLE_MAT3,
GL.GL_DOUBLE_MAT4,
GL.GL_DOUBLE_MAT2x3,
GL.GL_DOUBLE_MAT2x4,
GL.GL_DOUBLE_MAT3x2,
GL.GL_DOUBLE_MAT3x4,
GL.GL_DOUBLE_MAT4x2,
GL.GL_DOUBLE_MAT4x3,
GL.GL_SAMPLER_1D,
GL.GL_SAMPLER_2D,
GL.GL_SAMPLER_3D,
GL.GL_SAMPLER_CUBE,
GL.GL_SAMPLER_1D_SHADOW,
GL.GL_SAMPLER_2D_SHADOW,
GL.GL_SAMPLER_1D_ARRAY,
GL.GL_SAMPLER_2D_ARRAY,
GL.GL_SAMPLER_1D_ARRAY_SHADOW,
GL.GL_SAMPLER_2D_ARRAY_SHADOW,
GL.GL_SAMPLER_2D_MULTISAMPLE,
GL.GL_SAMPLER_2D_MULTISAMPLE_ARRAY,
GL.GL_SAMPLER_CUBE_SHADOW,
GL.GL_SAMPLER_BUFFER,
GL.GL_SAMPLER_2D_RECT,
GL.GL_SAMPLER_2D_RECT_SHADOW,
GL.GL_INT_SAMPLER_1D,
GL.GL_INT_SAMPLER_2D,
GL.GL_INT_SAMPLER_3D,
GL.GL_INT_SAMPLER_CUBE,
GL.GL_INT_SAMPLER_1D_ARRAY,
GL.GL_INT_SAMPLER_2D_ARRAY,
GL.GL_INT_SAMPLER_2D_MULTISAMPLE,
GL.GL_INT_SAMPLER_2D_MULTISAMPLE_ARRAY,
GL.GL_INT_SAMPLER_BUFFER,
GL.GL_INT_SAMPLER_2D_RECT,
GL.GL_UNSIGNED_INT_SAMPLER_1D,
GL.GL_UNSIGNED_INT_SAMPLER_2D,
GL.GL_UNSIGNED_INT_SAMPLER_3D,
GL.GL_UNSIGNED_INT_SAMPLER_CUBE,
GL.GL_UNSIGNED_INT_SAMPLER_1D_ARRAY,
GL.GL_UNSIGNED_INT_SAMPLER_2D_ARRAY,
GL.GL_UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE,
GL.GL_UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE_ARRAY,
GL.GL_UNSIGNED_INT_SAMPLER_BUFFER,
GL.GL_UNSIGNED_INT_SAMPLER_2D_RECT,
GL.GL_IMAGE_1D,
GL.GL_IMAGE_2D,
GL.GL_IMAGE_3D,
GL.GL_IMAGE_2D_RECT,
GL.GL_IMAGE_CUBE,
GL.GL_IMAGE_BUFFER,
GL.GL_IMAGE_1D_ARRAY,
GL.GL_IMAGE_2D_ARRAY,
GL.GL_IMAGE_2D_MULTISAMPLE,
GL.GL_IMAGE_2D_MULTISAMPLE_ARRAY,
GL.GL_INT_IMAGE_1D,
GL.GL_INT_IMAGE_2D,
GL.GL_INT_IMAGE_3D,
GL.GL_INT_IMAGE_2D_RECT,
GL.GL_INT_IMAGE_CUBE,
GL.GL_INT_IMAGE_BUFFER,
GL.GL_INT_IMAGE_1D_ARRAY,
GL.GL_INT_IMAGE_2D_ARRAY,
GL.GL_INT_IMAGE_2D_MULTISAMPLE,
GL.GL_INT_IMAGE_2D_MULTISAMPLE_ARRAY,
GL.GL_UNSIGNED_INT_IMAGE_1D,
GL.GL_UNSIGNED_INT_IMAGE_2D,
GL.GL_UNSIGNED_INT_IMAGE_3D,
GL.GL_UNSIGNED_INT_IMAGE_2D_RECT,
GL.GL_UNSIGNED_INT_IMAGE_CUBE,
GL.GL_UNSIGNED_INT_IMAGE_BUFFER,
GL.GL_UNSIGNED_INT_IMAGE_1D_ARRAY,
GL.GL_UNSIGNED_INT_IMAGE_2D_ARRAY,
GL.GL_UNSIGNED_INT_IMAGE_2D_MULTISAMPLE,
GL.GL_UNSIGNED_INT_IMAGE_2D_MULTISAMPLE_ARRAY,
GL.GL_UNSIGNED_INT_ATOMIC_COUNTER,
])
def variables_by_value(value):
    return _variable_enums[value]
